//
//  sdkDemoAppDelegate.m
//  sdkDemo
//
//  Created by qqconnect on 13-3-29.
//  Copyright (c) 2013年 qqconnect. All rights reserved.
//

#import "sdkDemoAppDelegate.h"
#import <TencentOpenAPI/TencentOAuth.h>
#import "sdkCall.h"
#import <Bugly/Bugly.h>

#if BUILD_QQAPIDEMO
#import "TencentOpenAPI/QQApiInterface.h"
#import "QQApiShareEntry.h"
#endif

#define OSVersion ([[[UIDevice currentDevice] systemVersion] floatValue])

@implementation sdkDemoAppDelegate

- (void)setIsRequestFromQQ:(BOOL)isRequestFromQQ
{
    _isRequestFromQQ = isRequestFromQQ;
    UINavigationBar *navBar = self.viewController.navigationController.navigationBar;
    UIColor *newColor = nil;
    if (_isRequestFromQQ)
    {
        // 46,139,87
        newColor = [UIColor colorWithRed:(46/255.0) green:(139/255.0) blue:(87/255.0) alpha:1.0];
    }
    else
    {
        newColor = nil;
    }
    
    if (OSVersion >= 7.0)
    {
        navBar.barTintColor = newColor;
    }
    else
    {
        navBar.tintColor = newColor;
    }
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    //打开写日志到文件的开关
    [QQApiInterface setSwitchPrintLogToFile:YES];
    //打印日志的回调
    [QQApiInterface startLogWithBlock:^(NSString *logStr) {
//        NSLog(@"=================%@",logStr);
    }];
    
    [Bugly startWithAppId:@"adf1669526"];
    
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    self.viewController = [[sdkDemoViewController alloc] initWithStyle:UITableViewStyleGrouped];
    sdkDemoNavgationController *navController = [[sdkDemoNavgationController alloc] initWithRootViewController:self.viewController];
    [[self window] setRootViewController:navController];
    [[self window] makeKeyAndVisible];
    self.isRequestFromQQ = NO;
    
    [self performSelector:@selector(showChangeAppIDAlert) withObject:nil afterDelay:0];
    
    return YES;
}

- (void)applicationDidEnterBackground:(UIApplication *)application{
    self.isRequestFromQQ = NO;
}

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation
{
#if (OPEN_SDK_UL_CI && OPEN_SDK_UL_DEBUG)
    static NSString *prefixUrl = @"https://qm.qq.com/qq_conn/222222";
    static NSString *bundleId = @"com.tencent.opensdkdemo.db.vip";
    
    // testcase: mqqsignapp
    if (NSNotFound != [url.absoluteString rangeOfString:@"mqqsignapp"].location) {
        NSRange queryRange = [url.absoluteString rangeOfString:@"?"];
        NSString *queryStrEx = [url.absoluteString substringFromIndex:queryRange.location+1];
        NSString *universallink = nil;
        if (NSNotFound != [url.absoluteString rangeOfString:bundleId].location) {
            universallink = [NSString stringWithFormat:@"%s/%s/mqqsignapp?%s", [prefixUrl UTF8String], [bundleId UTF8String], [queryStrEx UTF8String]];
        }
        else {
            universallink = [NSString stringWithFormat:@"%s/mqqsignapp?%s", [prefixUrl UTF8String], [queryStrEx UTF8String]];
        }
        url = [NSURL URLWithString:universallink];
        [QQApiInterface handleOpenUniversallink:url delegate:(id<QQApiInterfaceDelegate>)[QQApiShareEntry class]];
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Where from" message:url.description delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil, nil];
        [alertView show];
        return [TencentOAuth HandleUniversalLink:url];
    }
        
    // testcase: implfunction
    if (NSNotFound != [url.absoluteString rangeOfString:@"sdkactioninfo"].location) {
        // >=3.3.7 sdkactioninfo
        NSRange queryRange = [url.absoluteString rangeOfString:@"?"];
        NSString *queryStrEx = [url.absoluteString substringFromIndex:queryRange.location+1];
        NSString *universallink = [NSString stringWithFormat:@"%s/%s?%s", [prefixUrl UTF8String], [bundleId UTF8String], [queryStrEx UTF8String]];
        url = [NSURL URLWithString:universallink];
        [QQApiInterface handleOpenUniversallink:url delegate:(id<QQApiInterfaceDelegate>)[QQApiShareEntry class]];
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Where from" message:url.description delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil, nil];
        [alertView show];
        return [TencentOAuth HandleUniversalLink:url];
    }
    else {
        // == 3.3.6
        NSRange schemeRange = [url.absoluteString rangeOfString:@"tencent222222://"];
        NSString *schemePath = [url.absoluteString substringFromIndex:schemeRange.location+schemeRange.length];
        NSString *universallink = [NSString stringWithFormat:@"%s/tencent222222/%s", [prefixUrl UTF8String], [schemePath UTF8String]];
        url = [NSURL URLWithString:universallink];
        [QQApiInterface handleOpenUniversallink:url delegate:(id<QQApiInterfaceDelegate>)[QQApiShareEntry class]];
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Where from" message:url.description delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil, nil];
        [alertView show];
        return [TencentOAuth HandleUniversalLink:url];
    }
#endif
    
    [QQApiInterface handleOpenURL:url delegate:(id<QQApiInterfaceDelegate>)[QQApiShareEntry class]];
    
    if (YES == [TencentOAuth CanHandleOpenURL:url])
    {
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CI Where from" message:url.description delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil, nil];
        [alertView show];
        return [TencentOAuth HandleOpenURL:url];
    }
    return YES;
}

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url
{
    [QQApiInterface handleOpenURL:url delegate:(id<QQApiInterfaceDelegate>)[QQApiShareEntry class]];
    
    if (YES == [TencentOAuth CanHandleOpenURL:url])
    {
        return [TencentOAuth HandleOpenURL:url];
    }
    return YES;
}

- (BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void(^)(NSArray<id<UIUserActivityRestoring>> * __nullable restorableObjects))restorationHandler NS_AVAILABLE_IOS(8_0);
{
    // Demo处理手Q UniversalLink回调的示例代码
    if([userActivity.activityType isEqualToString:NSUserActivityTypeBrowsingWeb]) {
        NSURL *url = userActivity.webpageURL;
        if(url && [TencentOAuth CanHandleUniversalLink:url]) {
            UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CI UniversalLink" message:url.description delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil, nil];
            [alertView show];

            [QQApiInterface handleOpenUniversallink:url delegate:(id<QQApiInterfaceDelegate>)[QQApiShareEntry class]];
            return [TencentOAuth HandleUniversalLink:url];
        }
    }
    return YES;
}

#pragma mark -

- (void)showChangeAppIDAlert {
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"提示" message:@"设置AppId" preferredStyle:(UIAlertControllerStyleAlert)];
    [alert addAction:[UIAlertAction actionWithTitle:@"设置" style:(UIAlertActionStyleDefault) handler:^(UIAlertAction * _Nonnull action) {
        NSString *appid = alert.textFields.firstObject.text;
        
        [[NSUserDefaults standardUserDefaults] setObject:appid forKey:TENCENT_APPID_USERDEFAULTS_KEY];
        [[NSUserDefaults standardUserDefaults] synchronize];
        
        UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"提示" message:@"新AppId重新启动应用后生效" preferredStyle:(UIAlertControllerStyleAlert)];
        [alert addAction:[UIAlertAction actionWithTitle:@"确定" style:(UIAlertActionStyleCancel) handler:nil]];
        [[UIApplication sharedApplication].keyWindow.rootViewController presentViewController:alert animated:YES completion:nil];
    }]];
    [alert addAction:[UIAlertAction actionWithTitle:@"取消" style:(UIAlertActionStyleCancel) handler:nil]];
    
    [alert addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.clearButtonMode = UITextFieldViewModeAlways;
        textField.placeholder = @"输入AppId";
        textField.text = __TencentDemoAppid_;
    }];
    [[UIApplication sharedApplication].keyWindow.rootViewController presentViewController:alert animated:YES completion:nil];
}

@end
